if (typeof exmp === "undefined") {
    var exmp = {}
}
if (typeof exmp.websocket === "undefined") {
    exmp.websocket = {}
}
if (typeof exmp.websocket.core === "undefined") {
    exmp.websocket.core = {}
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
* a functor class of the application.
* get the value of country
*/
exmp.websocket.CountryValueFactory = {
    // a dummy function..
    create: function() {
        var locale = window.navigator.language.toLowerCase();
        if (locale == "en") {
            return "UK";
        } else if (locale == "ja") {
            return "Japan";
        }
        // defalut is USA..
        return "USA";
    }
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
* an utility class of the application.
*/
exmp.websocket.Util = { 
    escapeHtml: function(value) {
        return $("<div />").text(value).html();
    }
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
* a class of the application.
* used to wrap the websocket object.
*/
exmp.websocket.VisitorSocket = {
    
    ///////////////////////////////////////////////////////////////////////////
    // fields
    
    _socket: null,
    
    ///////////////////////////////////////////////////////////////////////////
    // public methods
    
    // initialize the object.
    init: function() {
        console.log("init");

        // create a new websocket object.
        // if necessary, change it to your server address.
        this._socket = new WebSocket("ws://127.0.0.1:8081/");
        
        // set the callback handler methods.
        this._socket.onopen = this._onopen;
        this._socket.onclose = this._onclose;
        this._socket.onmessage = this._onmessage;
        this._socket.onerror = this._onerror;
    },
    
    // send a message using the WebSocket.
    send: function(value) {
        console.log("send");

        // a value of string is like that,
        // {"person":"John Lennon","feeling":":)","country":"UK"}
        this._socket.send(value);
    },
    
    ///////////////////////////////////////////////////////////////////////////
    // callback methods
    
    // called when the WebSocket onopen. 
    _onopen: function() {
        console.log("open");
    },
    
    // called when the WebSocket onclose.
    _onclose: function() {
        console.log("close");
    },
    
    // called when the WebSocket onmessage.
    _onmessage: function(message) {
        console.log("message");

        // be pushed a message from WebSocket server.
        var visitor = eval("(" + message.data + ")");
        $("ul.feeds").prepend(
            $("<li />").html(
                "<a class='feed-feeling'>" + visitor.feeling + 
                "</a>" + "<b>" + visitor.person + "</b>" + " from " +
                "<b>" + visitor.country + "</b>"
            )
        )
    },
    
    // called when the WebSocket onerror.
    _onerror: function(e) {
        console.log("error");
        console.log(e);
    }
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
 * an entry class of the application.
 * 
 * @author hiroxpepe
 */
exmp.websocket.core.Application = function(sender) {
    $(document).ready(function() {
        sender.init();
    })
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
* a controller class of the application.
*/
exmp.websocket.core.Controller = window; {

    ///////////////////////////////////////////////////////////////////////////
    // public methods

    // init the controller class.
    exmp.websocket.core.Controller.init = function() {
        exmp.websocket.core.Controller._initComponent();
    }

    ///////////////////////////////////////////////////////////////////////////
    // event handler methods

    // an entry pad window be opened.
    exmp.websocket.core.Controller._doOpenCommandOnClick = function() {
        $("#open-command").click(function() {
            $("#pad-wrapper").show().css({
                top: -50,
                left: -50
            });
            $("#fine-entry-feeling").click();
        });
    }

    // an entry pad window be closed.
    exmp.websocket.core.Controller._doCloseCommandOnClick = function() {
        $("#close-command").click(function() {
            $("#pad-wrapper").hide(); 
        });
    }

    // a message be sent to server by the websocket object.
    exmp.websocket.core.Controller._doSendCommandOnClick = function() {
        $("#send-command").click(function() {
            // create a message.
            var first_name = exmp.websocket.Util.escapeHtml($("#first-name").val());
            var last_name = exmp.websocket.Util.escapeHtml($("#last-name").val());
            var feeling = $("#feeling-value").val();
            var country = exmp.websocket.CountryValueFactory.create();
            var param =
                '{"person":"' + first_name + " " + last_name + 
                '","feeling":"' + feeling + 
                '","country":"' + country + '"}';

            // send a message using the websocket object.
            exmp.websocket.VisitorSocket.send(
                param
            );
        });
    }

    // a feeling icon is clicked, 
    // the value of the param of feeling is set to hidden area.
    exmp.websocket.core.Controller._doFineEntryFeelingOnClick = function() {
        $("#fine-entry-feeling").click(function() {
            $("a.entry-feeling").css({"background-color": "silver"});
            $("#fine-entry-feeling").css({"background-color": "lemonchiffon"});
            $("#fine-entry-feeling").focus();
            $("#feeling-value").val(":)");
        });
    }

    exmp.websocket.core.Controller._doSadEntryFeelingOnClick = function() {
        $("#sad-entry-feeling").click(function() {
            $("a.entry-feeling").css({"background-color": "silver"});
            $("#sad-entry-feeling").css({"background-color": "lemonchiffon"});
            $("#sad-entry-feeling").focus();
            $("#feeling-value").val(":(");
        });
    }

    exmp.websocket.core.Controller._doCoolEntryFeelingOnClick = function() {
        $("#cool-entry-feeling").click(function() {
            $("a.entry-feeling").css({"background-color": "silver"});
            $("#cool-entry-feeling").css({"background-color": "lemonchiffon"});
            $("#cool-entry-feeling").focus();
            $("#feeling-value").val(":|");
        });
    }

    exmp.websocket.core.Controller._doWonderEntryFeelingOnClick = function() {
        $("#wonder-entry-feeling").click(function() {
            $("a.entry-feeling").css({"background-color": "silver"});
            $("#wonder-entry-feeling").css({"background-color": "lemonchiffon"});
            $("#wonder-entry-feeling").focus();
            $("#feeling-value").val(":o");
        });
    }

    ///////////////////////////////////////////////////////////////////////////
    // private methods

    // init a component of the controller class.
    exmp.websocket.core.Controller._initComponent = function() {
        
        // initialize the websocket object.
        exmp.websocket.VisitorSocket.init();
        
        // initialize event handler methods.
        exmp.websocket.core.Controller._doOpenCommandOnClick();
        exmp.websocket.core.Controller._doCloseCommandOnClick();
        exmp.websocket.core.Controller._doSendCommandOnClick();
        exmp.websocket.core.Controller._doFineEntryFeelingOnClick();
        exmp.websocket.core.Controller._doSadEntryFeelingOnClick();
        exmp.websocket.core.Controller._doCoolEntryFeelingOnClick();
        exmp.websocket.core.Controller._doWonderEntryFeelingOnClick();
        
        // and, do a some initialize.
        $("div.wrapper").draggable();
        $("#pad-wrapper").hide();
    }
}
/* 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
/**
 * called the main entry.
 * 
 * @author hiroxpepe
 */
new exmp.websocket.core.Application(
    this
);
